> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nmbr.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Populate a form

> Endpoint to populate form fields with the values suggested by Nmbr.

This is only possible for forms that support population.

This example uses an ROE form, but the same applies to other forms.



## OpenAPI

````yaml /spec/openapi.json post /form_types/{form_type}/populate
openapi: 3.0.0
info:
  title: Nmbr API
  description: API to interact with Nmbr Payroll
  version: 1.0.0
servers:
  - url: https://sandbox.nmbr.co/services/payroll
security:
  - CompanyToken: []
tags:
  - name: Accounting Codes
  - name: Accounting Code Rules
  - name: Adjustments
  - name: Allowances
  - name: Allowance Line Items
  - name: Allowance Types
  - name: Async Tasks
  - name: Bank Accounts
  - name: Business Entities
  - name: Business Entity Verifications
  - name: Business Entity ROE Authorizations
  - name: Business Presets
  - name: Calculations
  - name: Companies
  - name: Contractors
  - name: Deductions
  - name: Deduction Line Items
  - name: Deduction Types
  - name: Earnings
  - name: Earning Line Items
  - name: Earning Types
  - name: Effective Tax Properties
  - name: Employees
  - name: Employee Benefits
  - name: Employee Benefit Line Items
  - name: Employee Benefit Types
  - name: Employer Benefits
  - name: Employer Benefit Line Items
  - name: Employer Benefit Types
  - name: Employer Statutory Withholding Line Items
  - name: Employer Statutory Withholding Types
  - name: Forms
  - name: Form Batches
  - name: Form Types
  - name: Holidays
  - name: Integrations
  - name: Journal Entries
  - name: Overtime Rates
  - name: Partners
  - name: Pay Rates
  - name: Pay Schedules
  - name: Pay Splits
  - name: Pay Stubs
  - name: Payments
  - name: Payrolls
  - name: Reimbursements
  - name: Reimbursement Line Items
  - name: Reimbursement Types
  - name: Remittance Accounts
  - name: Remittance Account Enrollments
  - name: Reports
  - name: Statutory Withholding Line Items
  - name: Statutory Withholding Types
  - name: Tags
  - name: Tag Groups
  - name: Tax Properties
  - name: Tax Property Templates
  - name: Tokens
  - name: Usage Records
  - name: Usage Summaries
  - name: Vacation Pay
  - name: Vacation Pay Settings
  - name: Webhooks
  - name: Work Assignments
paths:
  /form_types/{form_type}/populate:
    post:
      tags:
        - Form Types
      summary: Populate a form
      description: |-
        Endpoint to populate form fields with the values suggested by Nmbr.

        This is only possible for forms that support population.

        This example uses an ROE form, but the same applies to other forms.
      operationId: form-types-populate
      parameters:
        - name: form_type
          in: path
          schema:
            type: string
          required: true
      requestBody:
        content:
          application/json:
            schema:
              allOf:
                - type: object
                  properties:
                    effective_date:
                      type: string
                      description: >-
                        Determines which form variant to populate. Must be a
                        date for which a populator is configured for the given
                        form type.
                      format: date
                - type: object
                  required:
                    - effective_date
            example:
              effective_date: '2026-01-01'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    description: The unique identifier of the object in Nmbr.
                    readOnly: true
                  object:
                    type: string
                    description: >-
                      The type of the object in Nmbr
                      (`"form_population_result"`).
                    readOnly: true
                  data:
                    $ref: '#/components/schemas/FormType'
              example:
                id: <id>
                object: form_population_result
                data:
                  fields:
                    block_8_social_insurance_number: '196710156'
                    employee_first_name: Marley
                    employee_last_name: Prosacco
                    employee_address_line_1: Angelina Ridge
                    employee_address_line_2: Toronto
                    employee_address_line_3: ON CA
                    employee_postal_code: M1M1M1
                    block_5_cra_payroll_account_number: 136549169RP9916
                    contact_area_code: 111
                    contact_phone_number: 2223333
                    contact_phone_number_extension: null
                    contact_first_name: Jean
                    contact_last_name: Smith
                    block_10_first_day_worked: '2026-01-01'
                    block_11_last_day_for_which_paid: '2026-01-31'
                    block_6_pay_period_type: M
                    block_12_final_pay_period_ending_date: '2026-01-31'
                    block_15_total_insurable_hours: '0'
                    pp1_insurable_earnings: 0
components:
  schemas:
    FormType:
      type: object
      title: Form Type
      properties:
        type:
          type: string
          description: The string identifier for this form type.
          nullable: true
          enum:
            - rl1
            - roe
            - t4
            - t4a
            - td1
            - td1ab
            - td1bc
            - td1mb
            - td1nb
            - td1nl
            - td1ns
            - td1nt
            - td1nu
            - td1on
            - td1pe
            - td1sk
            - td1x
            - td1yt
            - tp_1015_3_v
            - tp_1015_r_13_v
        label:
          type: string
          description: The human-readable display name for this form type.
          nullable: true
        version_year:
          type: number
          nullable: true
          format: decimal
        version_month:
          type: string
          nullable: true
        owner_types:
          type: array
          description: The owner types that can have forms of this type.
          nullable: true
          items:
            type: string
        exportable_as:
          type: object
          nullable: true
        supports_population:
          type: boolean
        supports_generation:
          type: boolean
        fields:
          type: array
          nullable: true
          items:
            type: object
            properties:
              key:
                type: string
                nullable: true
              label:
                type: string
                nullable: true
              type:
                type: string
                nullable: true
                enum:
                  - rl1
                  - roe
                  - t4
                  - t4a
                  - td1
                  - td1ab
                  - td1bc
                  - td1mb
                  - td1nb
                  - td1nl
                  - td1ns
                  - td1nt
                  - td1nu
                  - td1on
                  - td1pe
                  - td1sk
                  - td1x
                  - td1yt
                  - tp_1015_3_v
                  - tp_1015_r_13_v
              required:
                type: boolean
              readonly:
                type: boolean
  securitySchemes:
    CompanyToken:
      type: http
      scheme: bearer

````